<?php

namespace Sulfur;

use Sulfur\Filesystem;

class Upload
{
	// Error constants
	const ERROR_MAX_UPLOAD_SIZE = '10';
	const ERROR_MAX_FILE_SIZE = '20';
	const ERROR_PARTIAL_UPLOAD = '30';
	const ERROR_MISSING_UPLOAD = '40';
	const ERROR_MISSING_TEMP = '50';
	const ERROR_WRITING = '60';
	const ERROR_PHP_EXTENSION = '70';

	const ERROR_DISABLED = '80';
	const ERROR_KEY_MISSING = '90';
	const ERROR_FILTER_SIZE = '100';
	const ERROR_FILTER = '110';

	const ERROR_OTHER = '120';

	/**
	 * List of errors for last call to ::get
	 * @var array
	 */
	protected $errors = null;

	/**
	 * passed in $_FILES
	 * @var type
	 */
	protected $files = [];


	/**
	 * Filesystem
	 * @var Sulfur\Filesystem
	 */
	protected $filesystem;


	/**
	 * Maximum size
	 * @var int
	 */
	protected $size = null;


	/**
	 * Custom filters
	 * @var array
	 */
	protected $filters = [];

	/**
	 * Callback to generate a path or filename
	 * @var Callable
	 */
	protected $path;


	/**
	 * Pass in optional files array.
	 * @param array $files
	 * @param Sulfur\Filesystem $filesystem
	 */
	public function __construct(Filesystem $filesystem, $files = null)
	{
		$this->filesystem = $filesystem;

		if($files === null) {
			$files = $_FILES;
		}
		$this->files = $files;
	}


	/**
	 * Set max upload size
	 * @param int $size
	 * @return $this
	 */
	public function size($size)
	{
		$this->size = $size;
		return $this;
	}


	/**
	 * Set filters
	 * @param array|callable $filters array of callbacks of a callback. Callback should return true or false
	 * @return $this
	 */
	public function filter($filters)
	{
		if(is_array($filters) && count($filters) == 2 && isset($filters[1]) && is_string($filters[1])) {
			// array callback given
			$filters = [$filters];
		} elseif(! is_array($filters)) {
			// otherwise wrap it as array
			$filters = [$filters];
		}
		$this->filters = $filters;
		return $this;
	}


	/**
	 * Set a callback to create a file name / path
	 * @param Callable $path
	 */
	public function path($path)
	{
		$this->path = $path;
		return $this;
	}


	/**
	 * Get the errors generated by the last call to ::get
	 * @return array
	 */
	public function errors()
	{
		return $this->errors;
	}


	/**
	 * Get uploaded files of a certain key
	 * Outputs an array of the form
	 * [
	 *	['file' => [absolute filename], 'name' => [filename of the upload] ]
	 * ]
	 *
	 * @param string $key
	 * @param int $size
	 * @param array|callable $filters array of callbacks of a callback. Callback should return true or false
	 * @return array
	 */
	public function get($key, $size = null, $filters = null)
	{
		// start with empty sest of errros
		$this->errors = [];

		// check if allowed
        if (ini_get('file_uploads') == false) {
			$this->error(self::ERROR_DISABLED);
			return [];
        }

        // check if key exists
        if (! isset($this->files[$key])) {
            $this->error(self::ERROR_KEY_MISSING);
			return [];
        }

		// possible PHP errors
		$errors = [
			UPLOAD_ERR_OK => false,
			UPLOAD_ERR_INI_SIZE => self::ERROR_MAX_UPLOAD_SIZE,
			UPLOAD_ERR_FORM_SIZE => self::ERROR_MAX_FILE_SIZE,
			UPLOAD_ERR_PARTIAL => self::ERROR_PARTIAL_UPLOAD,
			UPLOAD_ERR_NO_FILE => self::ERROR_MISSING_UPLOAD,
			UPLOAD_ERR_NO_TMP_DIR => self::ERROR_MISSING_TEMP,
			UPLOAD_ERR_CANT_WRITE => self::ERROR_WRITING,
			UPLOAD_ERR_EXTENSION => self::ERROR_PHP_EXTENSION
		];

		// start with no files
		$files = [];

        // Collect file info
        if (is_array($this->files[$key]['tmp_name'])) {
            foreach ($this->files[$key]['tmp_name'] as $index => $tmp) {
				$error = $this->files[$key]['error'][$index];
                if (! isset($errors[$error]) || $errors[$error] === false) {
					$files[] = [
						'file' => $tmp,
						'name' => $this->files[$key]['name'][$index]
					];
                } else {
					$this->error(isset($errors[$error]) ? $errors[$error] : self::ERROR_OTHER, $this->files[$key]['name'][$index]);
				}
            }
        } else {
			$error = $this->files[$key]['error'];
			if (! isset($errors[$error]) || $errors[$error] === false) {
				$files[] = [
					'file' => $this->files[$key]['tmp_name'],
					'name' => $this->files[$key]['name']
				];
			} else {
				$this->error(isset($errors[$error]) ? $errors[$error] : self::ERROR_OTHER, $this->files[$key]['name']);
			}
        }

		// get local or global size
		if($size === null) {
			$size = $this->size;
		}

		// get local or global filter
		if($filters === null) {
			$filters = $this->filters;
		} else {
			if(! is_array($filters)) {
				$filters = [$filters];
			}
		}

		// get filtered files
		$filtered = [];
		foreach($files as $info) {
			$passed = true;

			// check max file size
			if($size !== null && $size > 0) {
				if(filesize($info['file']) > $size) {
					$this->error(self::ERROR_FILTER_SIZE, $info['name']);
					$passed = false;
				}
			}

			// check filters
			foreach($filters as $name => $filter) {

				if(is_callable($filter)) {
					if(! call_user_func($filter, $info['file'])) {
						$this->error(self::ERROR_FILTER, $info['name'], $name);
						$passed = false;
					}
				}
			}
			if($passed) {
				$filtered[] = $info;
			}
		}
		return $filtered;
	}


	/**
	 * Store uploaded files of a certain key
	 *
	 * @param string $key
	 * @param int $size
	 * @param array|callable $filters array of callbacks of a callback. Callback should return true or false
	 * @return array
	 */
	public function store($key, $size = null, $filters = null)
	{
		$result = [];
		foreach($this->get($key, $size, $filters) as $info) {

			// get the destination path
			if(is_callable($this->path)) {
				$path = call_user_func($this->path, $info['name'], $this->filesystem);
			} else {
				$path = $info['name'];
			}

			// get path info
			$parts = pathinfo($path);

			// make sure directory exists
			if(! $this->filesystem->has($parts['dirname'])) {
				$this->filesystem->createDir($parts['dirname']);
			}

			// dont overwrite files but rename them
			if($this->filesystem->has($path)) {
				$number = 2;
				while($this->filesystem->has($parts['dirname'] . DIRECTORY_SEPARATOR . $parts['filename'] . '-' . $number . '.' . $parts['extension'])) {
					$number++;
				}
				$path = $parts['dirname'] . DIRECTORY_SEPARATOR . $parts['filename'] . '-' . $number . '.' . $parts['extension'];
			}

			// write contents of upload to filesystem
			$this->filesystem->write($path, file_get_contents($info['file']));

			// replace upload file with actual filepath
			$info['file'] = $path;

			// add it to the result
			$result[] = $info;
		}
		return $result;
	}


	/**
	 * Add an error to the stack
	 * @param string $error
	 * @param string $file
	 * @param string|int $filter
	 */
	protected function error($error, $file = null, $filter = null) {
		$this->errors[] = [
			'error' => $error,
			'file' => $file,
			'filter' => $filter
		];
	}
}